// To parse this JSON data, do
//
//     final getNudgeLeaderboard = getNudgeLeaderboardFromJson(jsonString);

import 'dart:convert';

GetNudgeLeaderboard getNudgeLeaderboardFromJson(String str) =>
    GetNudgeLeaderboard.fromJson(json.decode(str));

String getNudgeLeaderboardToJson(GetNudgeLeaderboard data) =>
    json.encode(data.toJson());

class GetNudgeLeaderboard {
  String status;
  Data data;

  GetNudgeLeaderboard({
    required this.status,
    required this.data,
  });

  factory GetNudgeLeaderboard.fromJson(Map<String, dynamic> json) =>
      GetNudgeLeaderboard(
        status: json["status"],
        data: Data.fromJson(json["data"]),
      );

  Map<String, dynamic> toJson() => {
        "status": status,
        "data": data.toJson(),
      };
}

class Data {
  User user;
  int rank;
  List<User> users;

  Data({
    required this.user,
    required this.rank,
    required this.users,
  });

  factory Data.fromJson(Map<String, dynamic> json) => Data(
        user: User.fromJson(json["user"]),
        rank: json["rank"],
        users: List<User>.from(json["users"].map((x) => User.fromJson(x))),
      );

  Map<String, dynamic> toJson() => {
        "user": user.toJson(),
        "rank": rank,
        "users": List<dynamic>.from(users.map((x) => x.toJson())),
      };
}

class User {
  String id;
  UserId? userId;
  RewardId rewardId;
  String compositeId;
  int score;
  DateTime createdAt;
  DateTime updatedAt;
  int v;

  User({
    required this.id,
    required this.userId,
    required this.rewardId,
    required this.compositeId,
    required this.score,
    required this.createdAt,
    required this.updatedAt,
    required this.v,
  });

  factory User.fromJson(Map<String, dynamic> json) => User(
        id: json["_id"],
        userId: json["userId"] == null ? null : UserId.fromJson(json["userId"]),
        rewardId: rewardIdValues.map[json["rewardId"]]!,
        compositeId: json["compositeId"],
        score: json["score"],
        createdAt: DateTime.parse(json["createdAt"]),
        updatedAt: DateTime.parse(json["updatedAt"]),
        v: json["__v"],
      );

  Map<String, dynamic> toJson() => {
        "_id": id,
        "userId": userId?.toJson(),
        "rewardId": rewardIdValues.reverse[rewardId],
        "compositeId": compositeId,
        "score": score,
        "createdAt": createdAt.toIso8601String(),
        "updatedAt": updatedAt.toIso8601String(),
        "__v": v,
      };
}

enum RewardId { THE_6454_CFEA3_E41_F03_EA9_DFC411 }

final rewardIdValues = EnumValues(
    {"6454cfea3e41f03ea9dfc411": RewardId.THE_6454_CFEA3_E41_F03_EA9_DFC411});

class UserId {
  String id;
  String name;
  String email;
  String externalId;
  String photoUrl;

  UserId({
    required this.id,
    required this.name,
    required this.email,
    required this.externalId,
    required this.photoUrl,
  });

  factory UserId.fromJson(Map<String, dynamic> json) => UserId(
        id: json["_id"],
        name: json["name"],
        email: json["email"],
        externalId: json["externalId"],
        photoUrl: json["photoUrl"],
      );

  Map<String, dynamic> toJson() => {
        "_id": id,
        "name": name,
        "email": email,
        "externalId": externalId,
        "photoUrl": photoUrl,
      };
}

class EnumValues<T> {
  Map<String, T> map;
  late Map<T, String> reverseMap;

  EnumValues(this.map);

  Map<T, String> get reverse {
    reverseMap = map.map((k, v) => MapEntry(v, k));
    return reverseMap;
  }
}
